From 44ce805744f69d7a2407a5ae0f3c79dff6f857c4 Mon Sep 17 00:00:00 2001
From: Raymond Yau <superquad.vortex2@gmail.com>
Date: Sat, 8 Oct 2011 14:44:12 +0800
Subject: [PATCH] alsa-lib - add headphone as standard pcm device

- add headphone as standard pcm device
- add 'headphone' device to HDA-Intel.conf

Signed-off-by: Raymond Yau <superquad.vortex2@gmail.com>

diff --git a/src/conf/alsa.conf b/src/conf/alsa.conf
index bc91df3..8d1d4ab 100644
--- a/src/conf/alsa.conf
+++ b/src/conf/alsa.conf
@@ -90,6 +90,8 @@ defaults.pcm.center_lfe.card defaults.pcm.card
 defaults.pcm.center_lfe.device defaults.pcm.device
 defaults.pcm.side.card defaults.pcm.card
 defaults.pcm.side.device defaults.pcm.device
+defaults.pcm.headphone.card defaults.pcm.card
+defaults.pcm.headphone.device defaults.pcm.device
 defaults.pcm.surround40.card defaults.pcm.card
 defaults.pcm.surround40.device defaults.pcm.device
 defaults.pcm.surround41.card defaults.pcm.card
@@ -131,6 +133,7 @@ pcm.front cards.pcm.front
 pcm.rear cards.pcm.rear
 pcm.center_lfe cards.pcm.center_lfe
 pcm.side cards.pcm.side
+pcm.headphone cards.pcm.headphone
 pcm.surround40 cards.pcm.surround40
 pcm.surround41 cards.pcm.surround41
 pcm.surround50 cards.pcm.surround50
diff --git a/src/conf/cards/HDA-Intel.conf b/src/conf/cards/HDA-Intel.conf
index d4f2667..4af837f 100644
--- a/src/conf/cards/HDA-Intel.conf
+++ b/src/conf/cards/HDA-Intel.conf
@@ -146,6 +146,18 @@ HDA-Intel.pcm.iec958.0 {
 	hint.device 1
 }
 
+<confdir:/pcm/headphone.conf>
+HDA-Intel.pcm.headphone.0 {
+	@args [ CARD ]
+	@args.CARD {
+		type string
+	}
+	type hw
+	card $CARD
+	device 2
+	hint.device 2
+}
+
 <confdir:pcm/hdmi.conf>
 
 HDA-Intel.pcm.hdmi.common {
diff --git a/src/conf/pcm/Makefile.am b/src/conf/pcm/Makefile.am
index cc3286e..0af07be 100644
--- a/src/conf/pcm/Makefile.am
+++ b/src/conf/pcm/Makefile.am
@@ -1,4 +1,5 @@
 cfg_files = default.conf front.conf rear.conf center_lfe.conf side.conf\
+	    headphone.conf \
 	    surround40.conf surround41.conf \
 	    surround50.conf surround51.conf \
 	    surround71.conf iec958.conf hdmi.conf modem.conf \
diff --git a/src/conf/pcm/headphone.conf b/src/conf/pcm/headphone.conf
new file mode 100644
index 0000000..4d762ea
--- /dev/null
+++ b/src/conf/pcm/headphone.conf
@@ -0,0 +1,57 @@
+#
+# Hardware output from headphone
+#
+
+pcm.!headphone {
+	@args [ CARD DEV ]
+	@args.CARD {
+		type string
+		default {
+			@func getenv
+			vars [
+				ALSA_HEADPHONE_CARD
+				ALSA_CARD
+			]
+			default {
+				@func refer
+				name defaults.pcm.headphone.card
+			}
+		}
+	}
+	@args.DEV {
+		type integer
+		default {
+			@func igetenv
+			vars [
+				ALSA_HEADPHONE_DEVICE
+			]
+			default {
+				@func refer
+				name defaults.pcm.headphone.device
+			}
+		}
+	}
+	type empty
+	slave.pcm {
+		@func refer
+		name {
+			@func concat
+			strings [
+				"cards."
+				{
+					@func card_driver
+					card $CARD
+				}
+				".pcm.headphone." $DEV ":CARD=" $CARD
+			]
+		}
+	}
+	hint {
+		show {
+			@func refer
+			name defaults.namehint.basic
+		}
+		description "Headphone"
+		device $DEV
+	}
+}
-- 
1.6.0.6

